/**********************************************************
* @ File name -> lcd12864.c
* @ Version   -> V1.1.2
* @ Date      -> 11-30-2013
* @ Brief     -> LCD12864
*                ST7920оƬ

 V1.1
* @ Revise    -> A궨塣
* @           -> BӴڡת궨壬ӶԸٶMCUͨѶƵʱ
* @           -> Cʾַʾѡ񣬼ʾٸASCIIʾַx2
* @           -> Dȥʾ麯ϲַʾ 

 V1.1.1
* @ Revise    -> ַʾԴҪʾλʾһַ 

 V1.1.2
* @ Revise    -> AӶԵپϵͳMCUͨѶƵǷʹõĺ궨
* @           -> BڼҺæʱ˳Ԥѭ
**********************************************************/

#include "lcd12864.h"

/**********************************************************
                    Զʾַ                        
**********************************************************/

#define CGRAM_Value   64	//дCGRAM 
  
u8 code CGROM_Code[] = {
						//ͼ	
						0xff,0xff,0x80,0x01,0xbf,0xfd,0xdf,0xfb,0xec,0x37,0xf6,0x6f,0xfb,0xdf,0xfd,0xbf,
						0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xff,0xff,

						//ͼ
//						0x00,0x00,0x00,0x00,0x00,0x00,0x1c,0x70,0x14,0xd8,0x1d,0x88,0x01,0x80,0x01,0x80,
//						0x01,0x80,0x01,0x80,0x01,0x88,0x00,0xc8,0x00,0x70,0x00,0x00,0x00,0x00,0x00,0x00,   

						//ͼ
						0x07,0xe0,0x0e,0x70,0x1e,0xb8,0x3e,0xdc,0x36,0xec,0x3a,0xdc,0x3c,0xbc,0x3e,0x7c,
						0x3e,0x7c,0x3c,0xbc,0x3a,0xdc,0x36,0xec,0x3e,0xdc,0x1e,0xb8,0x0e,0x70,0x07,0xe0,

						//CDͼ
						0xff,0xff,0xff,0xff,0xff,0xff,0xe3,0x07,0xc9,0xb3,0x9d,0xb9,0x9f,0xb9,0x9f,0xb9,
						0x9f,0xb9,0x9f,0xb9,0x9d,0xb9,0xc9,0xb3,0xe3,0x07,0xff,0xff,0xff,0xff,0xff,0xff,

						//ָ
						0x00,0x00,0x1e,0x00,0x12,0x00,0x73,0xfc,0x52,0x02,0x52,0x1c,0x53,0xe0,0x52,0x10,
						0x53,0xe0,0x52,0x10,0x53,0xe0,0x52,0x10,0x73,0xe0,0x12,0x00,0x1e,0x00,0x00,0x00			
						};

//=========================================================

#ifdef LCD_Work_Mode	//ˣʹòڹģʽ

//=========================================================

/**********************************************************
*  ---> LCD12864жæ
* ڲ ---> none
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void LCD_Check_Busy(void)
{
	static u16 busytimeout;	//æʱ

    //=====================================================
    
    #ifdef LCD_USE_DELAY   /*  ʹʱͨѶƵ    */

    //=====================================================
    
	ktdata = 0xf0;	//ݿȫλ
	do
	{
		busytimeout++;
		if(busytimeout > 300)	break;

		LCD_RS = 0;
		LCD_Delay();
		LCD_RW = 1;
		LCD_Delay();
		LCD_EN = 1;
		LCD_Delay();
	}while(ktdata & LCD_Busy == LCD_Busy);	//ȴLCDæ
	LCD_EN = 0;	

    //=====================================================

    #else   /*  ûʹ  */

    //=====================================================

    ktdata = 0xf0;	//ݿȫλ
	do
	{
		busytimeout++;
		if(busytimeout > 300)	break;

		LCD_RS = 0;
		LCD_RW = 1;
		LCD_EN = 1;
//		LCD_Delay();
	}while(ktdata & LCD_Busy == LCD_Busy);	//ȴLCDæ
	LCD_EN = 0;

    //=====================================================
    
    #endif

    //=====================================================

	if(busytimeout >= 300)	printf("LCD Busy TimeOut...\r\n");
	busytimeout = 0;
}
/**********************************************************
*  ---> LCDдһֽݣжæ־8λһηϣ
* ڲ ---> datҪдֽ
*               ordжdatݣ0Ϊ1Ϊ
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void LCD_Write_Byte(u8 dat,u8 ord)
{
    //=====================================================
    
    #ifdef LCD_USE_DELAY   /*  ʹʱͨѶƵ    */

    //=====================================================
    
    LCD_Check_Busy();	//жǷæ
	LCD_EN = 0;
	LCD_Delay();
	LCD_RW = 0;
	LCD_Delay();

	if(ord & 0x01)	LCD_RS = 1;	//ݻжλ
	else	LCD_RS = 0;	

	LCD_EN = 1;
	LCD_Delay();
	ktdata = dat;	//
	LCD_Delay();
	LCD_EN = 0;

    //=====================================================

    #else   /*  ûʹ  */

    //=====================================================

    LCD_Check_Busy();	//жǷæ
	LCD_EN = 0;
	LCD_RW = 0;

	if(ord & 0x01)	LCD_RS = 1;	//ݻжλ
	else	LCD_RS = 0;	

	LCD_EN = 1;
	ktdata = dat;	//
	LCD_EN = 0;

    //=====================================================
    
    #endif

    //=====================================================
}

//=========================================================

#else	//ûʹôͨѶģʽ

//=========================================================

/**********************************************************
*  ---> LCDֽ
* ڲ ---> dtֽڣ5λںڲ趨Ϊ1
*               ֻȷRWRSΪλҲڲȷ
* ֵ ---> none
* ˵ ---> ȴһֽڣ51
*               һڣʱãҴд
*               ͬŵλָ䷽R/Wȷ
*               ǶдʹʣRSȷĴ
*               ݼĴĵڰλһ0
**********************************************************/
void LCD12864_Start(u8 dt)
{
	u8 dat,j;

	dat = dt | 0xf8;	//5λ趨Ϊ1ڰλ趨Ϊ0
	LCD_SCL = 0;
	LCD_Delay();LCD_Delay();
	LCD_CS = 1;	//ѡʾߵƽЧ
	for(j = 0;j < 8;j++)
	{
		if(dat & 0x80)	LCD_SDA = 1;	//ݵ
		else	LCD_SDA = 0;
			
		LCD_Delay();LCD_Delay();LCD_Delay();
		LCD_SCL = 1;	//ݣЧ
		LCD_Delay();LCD_Delay();LCD_Delay();
		LCD_SCL = 0;
		dat <<= 1;	//һλȷǸλ
	}
	LCD_Delay();LCD_Delay();LCD_Delay();
	LCD_SCL = 0;
	LCD_Delay();LCD_Delay();LCD_Delay();	//ȴӲӦȴݷȫ	
}
/**********************************************************
*  ---> LCDдһֽ
* ڲ ---> datҪд
*               ordжΪ0Ϊ1Ϊ
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void LCD_Write_Byte(u8 dat,u8 ord)
{
	u8 tem;
	u8 i,j;

	tem = dat & 0xf0;	//ȷ͸4λ
	LCD12864_Start((ord << 1) | 0xf0);	//RWΪ0RSΪordдΪݸʽ
	for(j = 0;j < 2;j++)	//һֽݻη
	{
		LCD_SCL = 0;	//ߵƽ仯
		LCD_Delay();LCD_Delay();LCD_Delay();

		for(i = 0;i < 8;i++)
		{
			if(tem & 0x80)	LCD_SDA = 1;	//ݣε4λ
			else	LCD_SDA = 0;	

			LCD_Delay();LCD_Delay();LCD_Delay();
			LCD_SCL = 1;	//ݣЧ
			LCD_Delay();LCD_Delay();LCD_Delay();
			LCD_SCL = 0;
			tem <<= 1;	//һλȷǸλ
		}
		tem = (dat << 4) & 0xf0;	//4λٴη͵4λ
	}
	LCD_Delay();LCD_Delay();LCD_Delay();
	LCD_SDA = 0;
	LCD_Delay();LCD_Delay();LCD_Delay();
	LCD_SCL = 0;
	LCD_Delay();LCD_Delay();LCD_Delay();
	LCD_CS = 0;
	LCD_Delay();LCD_Delay();LCD_Delay();	//ȴӲӦȴݷȫ
}

//=========================================================

#endif

//=========================================================

/**********************************************************
*  ---> LCDʾλ
* ڲ ---> xУȡֵΧ1 ~ 4
*               yУȡֵΧ0 ~ 7
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void LCD_Set_xy(u8 x,u8 y)
{
	switch(x)
	{
		case 1:
					LCD_Write_Byte((One_LineAddress + y),0);	//дַ
					break;
		case 2:
					LCD_Write_Byte((Two_LineAddress + y),0);	//дַ
					break;
		case 3:
					LCD_Write_Byte((Three_LineAddress + y),0);	//дַ
					break;
		case 4:
					LCD_Write_Byte((Four_LineAddress + y),0);	//дַ
					break;
		default:
					LCD_Write_Byte((One_LineAddress + y),0);	//дַ
					break;
	}
}
/**********************************************************
*  ---> дԶַLCDCGRAM
* ڲ ---> *data_codeд
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void LCD_Write_CGRAM(u8 *data_code)
{
	u8 i;
	LCD_Write_Byte(0x34,0);	//ַչָ
	LCD_Write_Byte(0x02,0);	//SR=0
	LCD_Write_Byte(0x30,0);	//ָָ
	LCD_Write_Byte(0x40,0);	//CGRAMַ
	for(i = 0;i < CGRAM_Value;i++)
	{
		LCD_Write_Byte(data_code[i*2],1);
		LCD_Write_Byte(data_code[i*2+1],1);
	}
}
/**********************************************************
*  ---> ʾһCGRAM
* ڲ ---> x
*               y
*               *strΪҪʾַ
*               add_hCGRAMλַ
*               add_lCGRAMλַ
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void Display_CGRAM(u8 x,u8 y,u8 add_h,u8 add_l)
{
	LCD_Set_xy(x,y);	//ʾַ
	LCD_Write_Byte(add_h,1);
	LCD_Write_Byte(add_l,1);
}
/**********************************************************
*  ---> LCDʾַ
* ڲ ---> x
*               y
*               *strҪʾַ
*               lenʾĳ
* ֵ ---> none
* ˵ ---> ֻܴĿͷʼʾlenַ
**********************************************************/
void Display_String(u8 x,u8 y,u8 *str,u8 len)
{
	LCD_Set_xy(x,y);	//ʾַ
	while(len--)
	{
		LCD_Write_Byte(*str,1);
		str++;
	}
}
/**********************************************************
*  ---> LCDʾַ
* ڲ ---> x
*               y
*               *strҪʾַ
*               lenʾĳ
* ֵ ---> none
* ˵ ---> Դʾλstarsumʼʾlenȵַ
**********************************************************/
void Display_String1(u8 x,u8 y,u8 *str,u8 starsum,u8 len)
{
	u8 i;

	LCD_Set_xy(x,y);	//ʾַ

	for(i = starsum;i < starsum + len;i++)
	{
		LCD_Write_Byte(str[i],1);
	}
}
/**********************************************************
*  ---> LCDдGDRAMͼ
* ڲ ---> x
*               y
*               widthʾͼƬĿ
*               hieghtʾͼƬĸ߶
*               *bmpҪʾַ
*               dis_modeʾģʽǰʾȫʾ
*                         0ʾ1ȫʾ
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void Display_GDRAM(u8 x,u8 y,u8 width,u8 height,u8 *bmp,u8 dis_mode)
{
	u8 i,j,k;
	u8 base_x,base_y;	//ʼ

	/******ȫͼʾ******/
	if(dis_mode)
	{
		switch(x)
		{
			case 1:
					base_y = One_LineAddress + y;
					break;
			case 2:
					base_y = Two_LineAddress + y;
					break;
			case 3:
					base_y = Three_LineAddress + y;
					break;
			case 4:
					base_y = Four_LineAddress + y;
					break;
			default:	break;
		}
		 
	 	LCD_Write_Byte(MPU_8bit_Expansion_Draw_Close,0);	//ָ
		LCD_Write_Byte(MPU_8bit_Expansion_Draw_Open,0);	//򿪻ͼ
		
		for(j = 0;j < height;j++)	//32
		{
			LCD_Write_Byte(base_y + j,0);	//дкţڼпʼ
			LCD_Write_Byte(One_LineAddress,0);	//ĵڼֽڿʼд
			
			for(i = 0;i < width;i++)	//ϰ
			{
				LCD_Write_Byte(bmp[width * j + i],1);	//ʼд
			}
			for(k = 0;k < width;k++)	//°
			{
			 	LCD_Write_Byte(bmp[width * (j + height) + k],1);	//ʼд
			}
		} 		
	}
	/******ֿϰ°д******/
	else
	{
		switch(x)	//жʾĺ꣬ȷʼ
		{
			case 1:	//ϰ
					base_x = One_LineAddress;	//ʼַΪ0x80
					break;
	
			case 2:	//°
					base_x = One_LineAddress;	//ʼַΪ0x80
					break;
	
			case 3:	//°
					base_x = Three_LineAddress;	//ʼַΪ0x88
					break;
			default:
					break;
		}
		
		base_y = base_x + y;	//x᷽ƫƣַ + ƫƵַ
		
		LCD_Write_Byte(MPU_8bit_Expansion_Draw_Close,0);	//ָ
		LCD_Write_Byte(MPU_8bit_Expansion_Draw_Open,0);	//򿪻ͼ
		
		if(x == 1 || x == 3)	//ֱͬһģֱд32λ
		{
			for(i = 0;i < 32;i++)	//дַндֱдˮƽ趨ͼRAMַ˵
			{ 
				LCD_Write_Byte(One_LineAddress + i,0);	//д봹ֱַϰ°
				LCD_Write_Byte(base_y,0);	//дˮƽַ
				
				for(j = 0;j < 2;j++)	//8bitݣ16bit
				{
					LCD_Write_Byte(*bmp++,1);	//д
				}
			}
		}
		
		if(x == 2)	//ʾͬһϵģдϰд°
		{
			for(i = 0;i < 16;i++)	//ϰ16е
			{
				LCD_Write_Byte(Two_LineAddress + i,0);	//д봹ֱַ
				LCD_Write_Byte(base_y,0);	//дˮƽַ
				
				for(j = 0;j < 2;j++)	//8bitݣ16bit
				{
					LCD_Write_Byte(*bmp++,1);	//д
				}
			}
			for(i = 0;i < 16;i++)	//°16е
			{
				LCD_Write_Byte(Three_LineAddress + i,0);	//д봹ֱַ
				LCD_Write_Byte(base_y + 8,0);	//дˮƽַ
				
				for(j = 0;j < 2;j++)	//8bitݣ16bit
				{
					LCD_Write_Byte(*bmp++,1);	//д
				}
			}
		}	  

	}
	LCD_Write_Byte(MPU_8bit_Expansion_Draw_Open,0);	//ָ򿪻ͼ
//	LCD_Write_Byte(Instruct_Basic8,0);
}	
/**********************************************************
*  ---> LCD12864
* ڲ ---> none
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void LCD_Clear(void)
{
	LCD_Write_Byte(Clear_Display,0);	//
}
/**********************************************************
*  ---> LCD12864ʼ
* ڲ ---> none
* ֵ ---> none
* ˵ ---> none
**********************************************************/	
void LCD_Init(void)
{
	/******PSBڲͨѶѡ******/

	#ifdef Soft_PSB	//ʹ

		#ifdef LCD_Work_Mode	//ˣʹòڹģʽ		
			LCD_PSB = 1;	//ߵƽΪͨѶģʽ
		#else
			LCD_PSB = 0;	//͵ƽΪͨѶģʽ
		#endif

	#endif

	/*********************************/

	LCD_RST = 0;	//ʾλ
	LCD_Delay();LCD_Delay();
	LCD_RST = 1;	
	LCD_Write_Byte(Instruct_Basic8,0);	//ָ8bitģʽ,0x30
	LCD_Write_Byte(Instruct_Basic8,0);	//ָ8bitģʽ,0x30
	LCD_Write_Byte(Open_Display,0);	//ʾأʾ׹,0x0c
	LCD_Write_Byte(Clear_Display,0);	//,0x01
	LCD_Write_Byte(Vernier_ShiftRight,0);	//趨㣬,0x06

	/*******************************/
	LCD_Write_CGRAM(CGROM_Code);	//дԶַ
}
/*********************************************************/


