/**********************************************************
* @ File name -> lcd12864.h
* @ Version   -> V1.1.2
* @ Date      -> 11-30-2013
* @ Brief     -> LCD12864ͷļ
*                ST7920оƬ

 V1.1
* @ Revise    -> A궨塣
* @           -> BӴڡת궨壬ӶԸٶMCUͨѶƵʱ
* @           -> Cʾַʾѡ񣬼ʾٸASCIIʾַx2
* @           -> Dȥʾ麯ϲַʾ

 V1.1.1
* @ Revise    -> ַʾԴҪʾλʾһַ 

 V1.1.2
* @ Revise    -> AӶԵپϵͳMCUͨѶƵǷʹõĺ궨
* @           -> BڼҺæʱ˳Ԥѭ
**********************************************************/

#ifndef _lcd12864_h_ 
#define _lcd12864_h_

/**********************************************************
                     ⲿͷļ
         Ӧõͬͷļ޸ļ                        
**********************************************************/

#include "config.h"

/**********************************************************
                    LCDģʽѡ                     
       LCDںʹѡ޸Ĵ˲Ӳ·       
**********************************************************/
#define LCD_Work_Mode			1	//0Ϊڹģʽ
									//1Ϊڹģʽ

#define LCD_USE_DELAY           1   //0: ΪʹʱͨѶƵʣ12MHzڵľ
                                        //1: ΪʹʱͨѶƵʣ12MHzϵľ

#define Soft_PSB				0	//0ʹӲƴ--->ģʽ
									//1ʹƴ--->ģʽ
                                        
/**********************************************************
                  ʱͨѶƵʲ
          ҪʹòͬƵʵ޸Ĵʱֵ
**********************************************************/ 

#define LCD_Delay()         delay_us(5);

/**********************************************************
                      ӿϢ                       
**********************************************************/

#ifdef	Soft_PSB	//ʹ
	
	#define LCD_PSB			P1_6	//LCDںʹͨѶѡ

#endif


#define LCD_RST			P1_4	//LCDλ

//=========================================================

#ifdef LCD_Work_Mode	/*	ڹģʽ	*/

//=========================================================

#define ktdata          P0	//8λݽӿ

#define LCD_EN			P1_0
#define LCD_RW			P1_1
#define LCD_RS			P1_5

//=========================================================

#else	/*	ڹģʽ	*/

//=========================================================

/***********ģʽʱӿڶ***********/

#define LCD_SCL			P1_0    //ӦܽΪEN
#define LCD_SDA			P1_1    //ӦܽΪRW
#define LCD_CS			P1_5    //ӦܽΪRS

//=========================================================

#endif	//ڡģʽѡ

//=========================================================

/**********************************************************
                        궨                       
**********************************************************/

#define LCD_Busy				0x80	//LCDæ־

#define Graph_BassADD			0x00	//ʾGRAMַ

//CGRAMʾַԪ
#define ANT_Graph				0x00
//#define Temperature_Graph		0x02
#define Bluetooth_Graph			0x02
#define CD_Graph				0x04
#define Hand_Graph				0x06

//////////////////////////////////////////////////////
//LCD12864ָ
//////////////////////////////////////////////////////
#define One_LineAddress			0x80	//һлַ
#define Two_LineAddress			0x90	//ڶлַ
#define Three_LineAddress		0x88	//лַ
#define Four_LineAddress		0x98	//лַ

//ָ궨
#define MPU_Busy				0x80	//LCDæͬʱҲ˵ַACֵ
#define Clear_Display			0x01	//ָ
#define Zero_Address			0x02	//ʾַ㣬AC = 0

//ָ궨
#define LCD_Standby				0x01	//ָRE = 1趨Ĵʹģʽ
                                        //˳дָ˳ٽRE = 0

/***********ָ***********/

//趨㣨entry mode set
// b7  b6  b5  b4  b3  b2  b1  b0
// 0   0   0   0   0   1   I/D  S 
#define Entry_ModeSet			0x04	//

#define Vernier_ShiftRight		(Entry_ModeSet | (1<<1))	//αƣAC+1
#define Vernier_ShiftLeft		(Entry_ModeSet | (0<<1))	//αƣAC-1

#define Frames_ShiftRight		(Vernier_ShiftLeft | 0x01)	//
#define Frames_ShiftLeft		(Vernier_ShiftRight | 0x01)	//

//ʾãdisplay status
// b7  b6  b5  b4  b3  b2  b1  b0
// 0   0   0   0   1   D   C   B 
#define Display_Status			0x08	//

#define Open_Display			(Display_Status | (1<<2))	//ʾ
#define Close_Display			(Display_Status | (0<<2))	//ʾ

#define Open_Vernier			(Display_Status | (1<<1))	//αʾ
#define Close_Vernier			(Display_Status | (0<<1))	//αʾ

#define Vernier_White_Open		(Display_Status | 0x01)	//αλʾ׿
#define Vernier_White_Close		(Display_Status | 0x00)	//αλʾ׹أʾ

//αʾλƣcursor and display shift control
// b7  b6  b5  b4  b3    b2   b1  b0
// 0   0   0   1   S/C  R/L1  X   X 
#define Cursor_Display_Control	0x10	//

#define Cursor_ShiftLeft		(Cursor_Display_Control | (0<<2))	//αƶAC = AC - 1
#define Cursor_ShiftRight		(Cursor_Display_Control | (1<<2))	//αƶAC = AC + 1
#define Display_ShiftLeft		(Cursor_Display_Control | (2<<2))	//ʾƶαƶAC = AC
#define Display_ShiftRight		(Cursor_Display_Control | (3<<2))	//ʾƶαƶAC = AC  

//趨function set
// b7  b6  b5  b4  b3  b2    b1  b0
// 0   0   1   DL  X   0/RE  X 	 X
#define Function_SetBasic		0x20	//

#define MPU_8bit				(Function_SetBasic | (1<<4))	//8bit MPUӿ
#define MPU_4bit				(Function_SetBasic | (0<<4))	//4bit MPUӿ

#define Instruct_Basic4			(MPU_4bit | (0<<2))				//4bit MPUӿڣָ
#define Instruct_Basic8			(MPU_8bit | (0<<2))				//8bit MPUӿڣָ

#define Instruct_Expansion4		(MPU_4bit | (1<<2))				//4bit MPUӿڣָ
#define Instruct_Expansion8		(MPU_8bit | (1<<2))				//8bit MPUӿڣָ

//趨CGRAMַ
// b7  b6  b5  b4  b3  b2  b1  b0
// 0   1   A5  A4  A3  A2  A1  A0
#define CGRAM_Set				0x40	//
//趨CGRAMַַACACΧΪ0x00 ~ 0x3fȷָSR = 0λûRAMַѡ

//趨DDRAMַ
// b7  b6  b5  b4  b3  b2  b1  b0
// 1   0   A5  A4  A3  A2  A1  A0
#define DDRAM_Set				0x80	//
//趨CGRAMַַAC

//дʾݵRAMRS = 1 RW = 0
// b7  b6  b5  b4  b3  b2  b1  b0
// D7  D6  D5  D4  D3  D2  D1  D0
//дݺʹACı䣬ÿRAMCGRAMDDRAMIRAMַд2ֽڵʾݣ
//дڶֽʱַACֵԶ1

//ȡʾݵRAMRS = 1 RW = 1
// b7  b6  b5  b4  b3  b2  b1  b0
// D7  D6  D5  D4  D3  D2  D1  D0
//ȡݺʹACı䣬趨RAMCGRAMDDRAMIRAMַҪDummy readһκܶȡȷʾݣ
//ڶζȡҪDummy read趨RAMַ

/***********ָ***********/

//λûRAMַѡ
// b7  b6  b5  b4  b3  b2  b1  b0
// 0   0   0   0   0   0   1   SR
#define Write_Roll_Address_Allow		0x03	//봹ֱַ
#define Write_IRAM_Address_Allow		0x02	//IRAMַָ趨CGRAMַָ

//ʾ
// b7  b6  b5  b4  b3  b2  b1  b0
// 0   0   0   0   0   1   0   R0
#define Display_White_One				0x04	//һзʾ
#define Display_White_Two				0x05	//ڶзʾ

//˯ģʽ
// b7  b6  b5  b4  b3  b2  b1  b0
// 0   0   0   0   1   SL  0   0
#define LCD_Sleep_Open					(0x08 | (1<<2))	//˯ģʽ
#define LCD_Sleep_Close					(0x08 | (0<<2))	//˳˯ģʽ

//书趨
// b7  b6  b5  b4  b3  b2  b1  b0
// 0   0   1   DL  X   RE  G   X
#define MPU_4bit_Basic_Draw_Open		(Instruct_Basic4 | (1<<1))	//4bit MPUӿڣָͼ
#define MPU_4bit_Basic_Draw_Close		(Instruct_Basic4 | (0<<1))	//4bit MPUӿڣָͼ

#define MPU_8bit_Basic_Draw_Open		(Instruct_Basic8 | (1<<1))	//8bit MPUӿڣָͼ
#define MPU_8bit_Basic_Draw_Close		(Instruct_Basic8 | (0<<1))	//8bit MPUӿڣָͼ

#define MPU_8bit_Expansion_Draw_Open	(Instruct_Expansion8 | (1<<1))	//8bit MPUӿڣָͼ
#define MPU_8bit_Expansion_Draw_Close	(Instruct_Expansion8 | (0<<1))	//8bit MPUӿڣָͼ

#define MPU_4bit_Expansion_Draw_Open	(Instruct_Expansion4 | (1<<1))	//4bit MPUӿڣָͼ
#define MPU_4bit_Expansion_Draw_Close	(Instruct_Expansion4 | (0<<1))	//4bit MPUӿڣָͼ

//趨IRAMַַ
// b7  b6  b5  b4  b3  b2  b1  b0
// 0   1   A5  A4  A3  A2  A1  A0
#define IRAM_Set						0x40	//
//SR = 1A5 ~ A0ΪֱַSR = 0A3 ~ A0ΪIRAMַ

//趨ͼRAMַ
// b7  b6  b5  b4  b3  b2  b1  b0
// 1   0   0   0   A3  A2  A1  A0 --->ˮƽַΧA3 ~ A0
// 1   A6  A5  A4  A3  A2  A1  A0 --->ֱַΧA6 ~ A0
#define Draw_RAMSet						0x80	//
//趨GDRAMַַACôֱλˮƽλãд2ֽɴֱˮƽã

/**********************************************************
                      ⲿܺ                      
**********************************************************/

void LCD_Init(void);	//LCD YB12864ZBʼ

void LCD_Clear(void);	//LCD YB12864ZB

void LCD_Write_Byte(u8 dat,u8 ord);	//LCDдһֽݣжæ־

void Display_String(u8 x,u8 y,u8 *str,u8 len);	//LCDʾַ

void Display_String1(u8 x,u8 y,u8 *str,u8 starsum,u8 len);	//LCDʾַ

void Display_CGRAM(u8 x,u8 y,u8 add_h,u8 add_l);	//ʾһCGRAM

void Display_GDRAM(u8 x,u8 y,u8 width,u8 height,u8 *bmp,u8 dis_mode);	//LCDдGDRAMͼ


#endif


/*********************************************************/

/*

 1ָ1RE = 0ָ
  ___________________________________________________________________________
 |               |  ź  |                               | ִ |
 |               |____________|_______________________________________| 	 |
 |   ָ    | RS | R/W   | D7 | D6 | D5 | D4 | D3 | D2 | D1 | D0 | ʱ |     HEX
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|
 |   ʾ    | 0  |   0   | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 1  | 1.6ms|     0x01
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|
 |   ַ0     | 0  |   0   | 0  | 0  | 0  | 0  | 0  | 0  | 1  | X  | 72us |     0x02 //ıDDRAM
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|
 |  趨   | 0  |   0   | 0  | 0  | 0  | 0  | 0  | 1  | I/D| S  | 72us |     0x06 α    0x07 
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|     0x04 α    0x05 
 | ʾ  | 0  |   0   | 0  | 0  | 0  | 0  | 1  | D  | C  | S  | 72us |   D = 1; ʾ  D = 0; ʾ // ıDDRAM     
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|   C = 1; αʾ  C = 0; αʾ  S = 1; αλʾ S = 0; ʾ     
 |   λ    | 0  |   0   | 0  | 0  | 0  | 1  | S/C| R/L| X  | X  | 72us |     0x10 αƶ AC = AC - 1   0x14 αƶ AC = AC + 1
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|     0x18 ʾƶ AC = AC       0x1c ʾƶ AC = AC
 |   趨    | 0  |   0   | 0  | 0  | 1  | DL | X  |0/RE| X  | X  | 72us |     0x30 8bitӿڣָ   0x34 8bitӿڣָ
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|     0x20 4bitӿڣָ   0x24 4bitӿڣָ 
 | 趨CGRAMַ | 0  |   0   | 0  | 1  | A5 | A4 | A3 | A2 | A1 | A0 | 72us |
 |_______________|____|_______|____|____|____|____|____|____|____|____|______| 趨CGRAMַַACACΧ0x00 ~ 0x3fȷָSR = 0
 | 趨DDRAMַ | 0  |   0   | 1  | 0  | A5 | A4 | A3 | A2 | A1 | A0 | 72us |
 |_______________|____|_______|____|____|____|____|____|____|____|____|______| 趨DDRAMַַACһACΧ 0x80 ~ 0x8f    ڶACΧ 0x90 ~ 0x9f 
 | æ־͵ַ| 0  |   1   | BF | A6 | A5 | A4 | A3 | A2 | A1 | A0 | 72us |
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|     BF = 0; //Խ
 |  дʾ   | 1  |   0   |                ʾ               | 72us |
 |_______________|____|_______|_______________________________________|______| ÿRAMCGRAMDDRAMIRAMַд2ֽڣڶֽʱACԶ1
 |  ʾ   | 1  |   1   |                ʾ               | 72us |
 |_______________|____|_______|_______________________________________|______| 趨RAMCGRAMDDRAMIRAMַҪDummy readٶһκܶȷʾ
                                                                               ݣڶζȡҪDummy readٶһΣRAMַ


 
 2ָ2RE = 1ָ
  ___________________________________________________________________________
 |               |  ź  |                               | ִ |
 |               |____________|_______________________________________| 	 |
 |   ָ    | RS | R/W   | D7 | D6 | D5 | D4 | D3 | D2 | D1 | D0 | ʱ |     HEX
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|
 |   ģʽ    | 0  |   0   | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 1  | 72us |     0x01   ָܸıRAM
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|
 |   ַ  | 0  |   0   | 0  | 0  | 0  | 0  | 0  | 0  | 1  | SR | 72us |
 |  RAMַѡ  |    |       |    |    |    |    |    |    |    |    |      | ʼֵ0x02 0x03 봹ֱַ
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|              0x02 IRAMַָ趨CGRAMַָ
 |   ʾ    | 0  |   0   | 0  | 0  | 0  | 0  | 0  | 1  | R1 | R0 | 72us |
 |_______________|____|_______|____|____|____|____|____|____|____|____|______| ʼֵ0x04   0x05ʾ
 |   ˯ģʽ    | 0  |   0   | 0  | 0  | 0  | 0  | 1  | SL | X  | X  | 72us |
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|     0x0c ˯ģʽ    0x08 ˯ģʽ
 |  书趨 | 0  |   0   | 0  | 0  | 1  | DL | X  |1/RE| G  | 0  | 72us |
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|
 |趨IRAMַ | 0  |   0   | 0  | 1  | A5 | A4 | A3 | A2 | A1 | A0 | 72us |
 |   ַ    |    |       |    |    |    |    |    |    |    |    |      |     SR = 1;	//A5 ~ A0Ϊֱַ
 |_______________|____|_______|____|____|____|____|____|____|____|____|______|     SR = 0;	//A3 ~ A0ΪIRAMַ
 |               |    |       |    | 0  | 0  | 0  | A3 | A2 | A1 | A0 |      |
 |               |    |       |    |____|____|____|____|____|____|____|      | 趨GDRAMַַACôֱַˮƽַ
 |趨ͼRAMַ| 0  |   0   | 1  | A6 | A5 | A4 | A3 | A2 | A1 | A0 | 72us | д2ֽɴֱˮƽַã
 |_______________|____|_______|____|____|____|____|____|____|____|____|______| ֱַΧAC6 ~ AC0
                                                                               ˮƽַΧAC3 ~ AC0
  
    书趨

	DL = 1;	//8bit MPUӿ      DL = 0;	//4bit MPUӿ

	RE = 1;	//ָ          RE = 0;	//ָ

	G = 1;	//ͼʾ        G = 0;	// ͼʾ

*/
